#include <iostream.h>

#include "vertex.h"
#include "shape.h"
#include "cross.h"
#include "hexagon.h"
#include "square.h"
#include "triangle.h"

/*
 * entry point
 */
int main(int argc, char* argv)
{
  Vertex crsData[] = { Vertex(1.0, 1.0), Vertex(1.0, -1.0), Vertex(-1.0, -1.0), Vertex(-1.0, 1.0) };
  Vertex hexData[] = { Vertex(1.0, 0.5), Vertex(1.0, -0.5), Vertex(-1.0, -1.0), Vertex(-1.0, -0.5), Vertex(-1.0, 0.5), Vertex(1.0, 1.0) };
  Vertex squData[] = { Vertex(1.0, 1.0), Vertex(1.0, -1.0), Vertex(-1.0, -1.0), Vertex(-1.0, 1.0) };
  Vertex triData[] = { Vertex(1.0, 1.0), Vertex(1.0, -1.0), Vertex(0.0, 0.0) };

  Shape* shapes[4]; // this is an array of pointers to the base class

  shapes[0] = new Cross(crsData);
  shapes[1] = new Hexagon(hexData);
  shapes[2] = new Square(squData);
  shapes[3] = new Triangle(triData);

  for (int i=0; i<4; i++) {
    Shape* shapePtr = shapes[i];
    shapePtr->draw(); // call the appropriate draw function
    shapePtr->destroy(); // delete storage inside the shape object - do not access now!
  }

  // try and create an object of type 'Shape' - compiler will not let you because
  // we have used a pure virtual function in Shape; deliberately!

  return 0;
}