#include <iostream.h>
#include <stdlib.h>

#include "vertex.h"
#include "shape.h"

/*
 * Shape (base class) constructor
 */
Shape::Shape(int _nv, Vertex* _v)
: nv(_nv), v(0)
{
  if (nv < 1) {
    cerr << "error: too few vertices to create a shape\n";
    exit(-1);
  }

  // create some memory to hold vertices
  v = new Vertex[nv];

  // check if we got the memory OK
  if (v == 0) {
    cerr << "error: not enough memory to create a shape\n";
    exit(-1);
  }

  // copy vertices passed to constructor to out storage
  for (int i=0; i<nv; i++) {
    v[i] = _v[i];
  }
}

/*
 * free up memory associated with this shape object
 */
void Shape::destroy()
{
  delete[] v;
}
